; Last Guardian II MPU MIDI driver by Mok v1.0

		ORG	0x100
		USE16
		CPU	386

start:
		cli
		call	Disable
		mov	sp, end_driver + 0x200
		mov	bx, sp
		shr	bx, 4
		inc	bx
		mov	ah, 0x4A
		int	0x21
		jc	near Crash

		mov	bx, 0x3000
		mov	ah, 0x48
		int	0x21	
		jc	Crash
		mov	[SmfSeg], ax
		add	ax, 0x1000
		mov	[DrvSeg], ax

		mov	ds, ax
		mov	dx, 0x100
		mov	bx, 10
		call	FileRead

		push	cs
		pop	ds
		mov	ax, 0x3521
		int	0x21
		mov	[old_int_21], bx
		mov	[old_int_21+2], es
		mov	ax, 0x2521
		mov	dx, Int21hook
		int	0x21				;hoot int21 to return after decompression
		cli
		mov	ax, [DrvSeg]
		mov	ds, ax
		mov	es, ax
		mov	ss, ax
		mov	sp, -2
		push	ax
		push	100h
		retf
ReturnHere:
		lds	dx, [cs:old_int_21]
		mov	ax, 0x2521
		int	0x21
		mov	ds, [cs:DrvSeg]
		mov	byte [0xbd77], 2		;set music output to midi
		mov	byte [0xbcc8], 0xcb		;retf after driver init

		call	far [cs:DrvCall]

		push	cs
		pop	ds
		mov	ax, 0x257F
		mov	dx, vect_hoot
		int	0x21
		sti
		call	Enable
mainloop:
		mov	ax, 0x9801
		int	0x18
		jmp	short mainloop

Crash:
		cli
		mov	bx, 0xDEAD
.loop:
		jmp	short .loop

FileRead:
		mov	cx, -1
		mov	ah, 0x3f
		int	0x21
		jc	Crash
		ret

Int21hook:
		cmp	ah, 0x30
		jnz	.old
		pop	ax
		cmp	ax, 0xc26a
		jnz	Crash			;check if correct version of game file
		pop	ax
		push	cs
		push	ReturnHere
		iret
.old:
		jmp	far [cs:old_int_21]
Disable:
		mov	al, 0x80
		jmp	short HootOut
Enable:
		mov	al, 0x81
HootOut:
		mov	dx, 0x7E8
		out	dx, al
		ret

vect_hoot:
		pusha
		push	ds
		push	es
		mov	ax, cs
		mov	ds, ax
		mov	es, ax
		call	Disable
		mov	dx, 0x7e0
		in	al, dx
		test	al, al
		jz	short .play
		cmp	al, 2
		jnz	.ed
		call	.stop
.ed:
		call	Enable
		pop	es
		pop	ds
		popa
		iret
.stop:
		mov	ah, 1
		int	0x48
		ret
.play:
		call	.stop

		xor	bx, bx
		mov	ds, [SmfSeg]
		xor	dx, dx
		call	FileRead
		cmp	dword [0], 'MThd'	;ignore trashed files
		jnz	short .ed

		push	ds
		pop	es
		xor	dx, dx
		xor	ah, ah
		int	0x48

		jmp	short .ed

		align 2

DrvCall:
		dw 0xbcc5
DrvSeg:
		dw 0
SmfSeg:
		dw 0
old_int_21:
		dd 0

end_driver:

		ends
		end

